/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

/* Generated by Together */

#ifndef PERFECTCFDDRIVER_H
#define PERFECTCFDDRIVER_H

#include "CfdState.h"

namespace cfd {

/*!
 * \class PerfectCfdDriver
 * \brief Perfect implementation class for the rio3 dpp device driver
 *
 * On start command, all actual values become target's ones.
 */
class PerfectCfdDriver: public CfdState {

public:

	/*!
	 * \brief Constructor
	 * \param[in] owner The device driver main class link
	 */
	PerfectCfdDriver(CfdDriver* owner);

	/*!
	 * \brief Destructor
	 */
	virtual ~PerfectCfdDriver();

	/*!
	 * \brief Init command implementation
	 */
	virtual void init();

	/*!
	 * \brief Write Param command implementation
	 */
	virtual void writeParam();

	/*!
	 * \brief Read Infos command implementation
	 */
	virtual void readInfos();

};

}

#endif //PERFECTCFDDRIVER_H
